// 是否已开启禁用
let enabled = false;
// 禁用复制/剪切功能
let handler = function (e) {
  e.preventDefault();
  window.postMessage({
    message: '禁止复制',
    type: 'warning'
  });
};

/**
 * 禁用复制
 */
function DisabledCopy() {
  if (!enabled) {
    document.body.addEventListener('copy', handler);
    enabled = true;

    console.log('复制禁用已开启');
  }
}

/**
 * 关闭禁用复制
 */
function LaunchCopy() {
  if (enabled) {
    document.body.removeEventListener('copy', handler);
    enabled = false;
    console.log('复制禁用已关闭');
  }
}


// export function butCopy5(that) {
//   copy("@hash686868");
//   that.$message({
//     type: "success",
//     message: "复制成功!",
//   });
// }

/**
 * 复制字符串文档至剪贴板
 * @param value 需要复制的内日
 */
function CopyContent(value: string) {
  let copyTextArea;
  copyTextArea = document.createElement("textarea");
  copyTextArea.style.height = "1px";
  copyTextArea.style.opacity = "0";
  copyTextArea.style.width = "1px";
  copyTextArea.style.MozUserSelect = "text";
  copyTextArea.style.userSelect = "text";
  copyTextArea.style.webkitUserSelect = "text";
  copyTextArea.style.pointerEvents = "auto";
  copyTextArea.remove("disabled");
  document.body.appendChild(copyTextArea);
  copyTextArea.value = value;
  copyTextArea.select();
  document.execCommand("copy");
}

export {
  CopyContent,
  DisabledCopy,
  LaunchCopy
}
