/**
 * 金额转换为大写
 * @param num 111.11
 * @returns 一百一十一元一角一分
 */

function NumberToCapital(num: string | number) {
  let minus = "";
  let m_str = "";
  const text = num.toString();
  const zh = '零壹贰叁肆伍陆柒捌玖';
  if (text.indexOf("-") === 0) {
    num = text.replace("-", "");
    minus = "负"
  }
  let money_num = Number(num);
  let money = Math.round(money_num * 100).toString(10);
  const len = money.length;
  for (let i = 0; i < len; i++) {
    m_str = m_str + zh.charAt(parseInt(money.charAt(i))) + sitToUnit(len - i - 1)
  }
  m_str = m_str.replace("零分", "");
  m_str = m_str.replace("零角", "零");
  let yy = 0;
  while (true) {
    let len = m_str.length;
    m_str = m_str.replace("零圆", "圆");
    m_str = m_str.replace("零万", "万");
    m_str = m_str.replace("零亿", "亿");
    m_str = m_str.replace("零仟", "零");
    m_str = m_str.replace("零佰", "零");
    m_str = m_str.replace("零零", "零");
    m_str = m_str.replace("零拾", "零");
    m_str = m_str.replace("亿万", "亿零");
    m_str = m_str.replace("万仟", "万零");
    m_str = m_str.replace("仟佰", "仟零");
    yy = m_str.length;
    if (yy === len) {
      break
    }
  }
  yy = m_str.length;
  if (m_str.charAt(yy - 1) === "零") {
    m_str = m_str.substring(0, yy - 1)
  }
  yy = m_str.length;
  if (m_str.charAt(yy - 1) === "圆") {
    m_str = m_str + "整"
  }
  return minus + m_str
}
function sitToUnit(a: number): string {
  if (a > 10) {
    a = a - 8;
    return (sitToUnit(a))
  }
  const zh = '分角圆拾佰仟万拾佰仟亿';
  return zh.charAt(a)
}

export {
  NumberToCapital
}