/**
 * 数组校验
 * @param value
 * @returns
 */
function IsArr(value: any) {
  return value && Object.prototype.toString.call(value) === "[object Array]";
}

/**
 * 非空校验
 * @param value
 * @returns
 */
function IsNonEmpty(value: string) {
  return !(value === null || value === undefined || String(value) === "");
}

/**
 * 非0校验
 * @param value
 * @returns
 */
function IsNonZero(value: string) {
  return !(value === null || value === undefined || String(value) === "" || Number(value) === 0);
}

/**
 *  删除 obj 中指定的元素
 * @param obj
 * @param key
 * @returns
 */
function DeleteObjKeys(obj: Object, key: string | string[]) {
  if (typeof key === "string") {
    return delete obj[key];
  }
  if (IsArr(key)) {
    return key.forEach((item) => {
      delete obj[item];
    });
  }
};

/**
 * 数组对象去重 arr 要去重的数组 默认用对象的 id 作为标识去重
 * @param arr 去重数组
 * @param arg 去重标识
 * @returns 去重后的数组
 */
function RepeatObj(arr: any[], arg: string) {
  let result = <any>[];
  const obj = {};
  for (const item in arr) {
    if (!obj[arr[item][arg]]) {
      result.push(arr[item]);
      obj[arr[item][arg]] = true;
    }
  }
  return result;
}

export {
  IsArr,
  IsNonEmpty,
  IsNonZero,
  DeleteObjKeys,
  RepeatObj
}